Developer Documentation

Classes | Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
OMPropertyVisualizer< MeshT > Class Template Reference
Inheritance diagram for OMPropertyVisualizer< MeshT >:

## Classes
class | CopyProperty

## Public Member Functions
| OMPropertyVisualizer (MeshT *_mesh, int objectID, const PropertyInfo &_propertyInfo)
virtual void | visualize (bool _setDrawMode, QWidget *_widget)
| Visualizes the property. More...
virtual void | removeProperty ()
| Removes the property. More...
virtual void | duplicateProperty ()
| Duplicates the property. More...
virtual void | clear ()
| Clears the property. More...
unsigned int | getClosestPrimitiveId (unsigned int _face, ACG::Vec3d &_hitPoint)
| Returns the ID of the closest primitive. More...
virtual QString | getPropertyText (unsigned int index)
| Returns the value of a property in text form. More...
Public Member Functions inherited from PropertyVisualizer
| PropertyVisualizer (const PropertyInfo &_propertyInfo)
| Constructor. More...
virtual | ~PropertyVisualizer ()
| Destructor.
virtual QString | getName ()
| Returns a beautiful name. More...
virtual QWidget * | getWidget ()
| Returns the visualizer's widget. More...
const PropertyInfo & | getPropertyInfo () const
| Returns the PropertyInfo.

## Protected Member Functions
virtual void | visualizeFaceProp (bool _setDrawMode=true)
virtual void | visualizeEdgeProp (bool _setDrawMode=true)
virtual void | visualizeHalfedgeProp (bool _setDrawMode=true)
virtual void | visualizeVertexProp (bool _setDrawMode=true)
template<typename PropType >
void | removeProperty_stage1 ()
template<typename PropType >
void | removeProperty_stage2 ()
template<typename PropType >
void | duplicateProperty_stage1 ()
template<typename PropHandle , typename Iterator >
void | duplicateProperty_stage2 (Iterator first, Iterator last)
virtual void | clearFaceProp ()
virtual void | clearEdgeProp ()
virtual void | clearHalfedgeProp ()
virtual void | clearVertexProp ()
virtual void | setFacePropertyFromText (unsigned int index, QString text)
virtual void | setEdgePropertyFromText (unsigned int index, QString text)
virtual void | setHalfedgePropertyFromText (unsigned int index, QString text)
virtual void | setVertexPropertyFromText (unsigned int index, QString text)
virtual void | setPropertyFromText (unsigned int index, QString text)
| Returns the value of a property in text form. More...
virtual int | getEntityCount ()
| Returns the number of entities.
virtual QString | getHeader ()
| Returns the header for saving.
unsigned int | getClosestFaceId (unsigned int _face, ACG::Vec3d &_hitPoint)
unsigned int | getClosestEdgeId (unsigned int _face, ACG::Vec3d &_hitPoint)
unsigned int | getClosestHalfedgeId (unsigned int _face, ACG::Vec3d &_hitPoint)
unsigned int | getClosestVertexId (unsigned int _face, ACG::Vec3d &_hitPoint)
template<typename InnerType >
QString | getPropertyText_ (unsigned int index)
template<typename Type >
void | showHistogram (ACG::QtWidgets::QtHistogramWidget *histogramWidget)
Protected Member Functions inherited from PropertyVisualizer
virtual std::unique_ptr< ACG::IColorCoder > | buildColorCoder ()
template<typename PropType , typename Iterable >
void | showHistogramT (ACG::QtWidgets::QtHistogramWidget *widget, Iterable data)

## Protected Attributes
MeshT * | mesh
int | mObjectID
Protected Attributes inherited from PropertyVisualizer
PropertyInfo | propertyInfo

## Additional Inherited Members
Signals inherited from PropertyVisualizer
void | log (Logtype _type, QString _message)
void | log (QString _message)
Static Public Member Functions inherited from PropertyVisualizer
static QString | toStr (bool b)
static QString | toStr (double d)
static QString | toStr (int i)
static QString | toStr (uint8_t i)
static QString | toStr (unsigned int i)
static QString | toStr (OpenMesh::Vec3d v)
static QString | toStr (OpenMesh::Vec2d v)
static QString | toStr (OpenMesh::Vec2f v)
static bool | strToBool (QString str)
static double | strToDouble (QString str)
static int | strToInt (QString str)
static unsigned int | strToUInt (QString str)
static OpenMesh::Vec3d | strToVec3d (QString str)
static OpenMesh::Vec2d | strToVec2d (QString str)
static OpenMesh::Vec2f | strToVec2f (QString str)
Public Attributes inherited from PropertyVisualizer
QWidget * | widget

## Detailed Description

### template<typename MeshT>
class OMPropertyVisualizer< MeshT >

Definition at line 55 of file OMPropertyVisualizer.hh.

## Member Function Documentation

## ◆ clear()

template<typename MeshT >

void OMPropertyVisualizer< MeshT >::clear | ( | void |  | ) |
| virtual

Clears the property.

This method clears the property by releasing the colors of the mesh.

Reimplemented from PropertyVisualizer.

Reimplemented in OMPropertyVisualizerVector< MeshT >, and OMPropertyVisualizerVector2< MeshT, VectorType >.

Definition at line 333 of file OMPropertyVisualizerT_impl.hh.

## ◆ duplicateProperty()

template<typename MeshT>

virtual void OMPropertyVisualizer< MeshT >::duplicateProperty | ( |  | ) |
| inline virtual

Duplicates the property.

This will duplicate the property.

Reimplemented from PropertyVisualizer.

Reimplemented in OMPropertyVisualizerVector< MeshT >, OMPropertyVisualizerVector2< MeshT, VectorType >, OMPropertyVisualizerVectorFieldDifference< MeshT >, OMPropertyVisualizerDouble< MeshT >, OMPropertyVisualizerInteger< MeshT, T >, and OMPropertyVisualizerBoolean< MeshT >.

Definition at line 83 of file OMPropertyVisualizer.hh.

## ◆ getClosestPrimitiveId()

template<typename MeshT >

unsigned int OMPropertyVisualizer< MeshT >::getClosestPrimitiveId | ( | unsigned int | _face,
|  | ACG::Vec3d & | _hitPoint
| ) |  |

Returns the ID of the closest primitive.

Parameters

  _face | The face that was hit.
  _hitPoint | The position where the face was hit.

Returns
  The ID of the primitive that is closest to the hitpoint.

This method is used for picking. For some entities it might be convenient to not pick them directly but pick faces instead. Then, this method iterates over the entities adjacent to the face and return the one that is closest to the actual hit point.

Definition at line 200 of file OMPropertyVisualizerT_impl.hh.

## ◆ getPropertyText()

template<typename MeshT >

QString OMPropertyVisualizer< MeshT >::getPropertyText | ( | unsigned int | i | ) |
| virtual

Returns the value of a property in text form.

Parameters

  i | The id of the entity whose property we want to know.

Returns
  The property value in text form.

Implements PropertyVisualizer.

Reimplemented in OMPropertyVisualizerVector< MeshT >, OMPropertyVisualizerVector2< MeshT, VectorType >, OMPropertyVisualizerVectorFieldDifference< MeshT >, OMPropertyVisualizerInteger< MeshT, T >, OMPropertyVisualizerDouble< MeshT >, and OMPropertyVisualizerBoolean< MeshT >.

Definition at line 142 of file OMPropertyVisualizerT_impl.hh.

## ◆ removeProperty()

template<typename MeshT>

virtual void OMPropertyVisualizer< MeshT >::removeProperty | ( |  | ) |
| inline virtual

Removes the property.

This will remove the property from the mesh. After this method the PropertyVisualizer should be deleted.

Reimplemented from PropertyVisualizer.

Reimplemented in OMPropertyVisualizerVector< MeshT >, OMPropertyVisualizerVector2< MeshT, VectorType >, OMPropertyVisualizerVectorFieldDifference< MeshT >, OMPropertyVisualizerDouble< MeshT >, OMPropertyVisualizerInteger< MeshT, T >, and OMPropertyVisualizerBoolean< MeshT >.

Definition at line 76 of file OMPropertyVisualizer.hh.

## ◆ setPropertyFromText()

template<typename MeshT >

void OMPropertyVisualizer< MeshT >::setPropertyFromText | ( | unsigned int | index,
|  | QString | text
| ) |  |
| protected virtual

Returns the value of a property in text form.

Parameters

  index | The id of the entity whose property should be set.
  text | The value in text form.

This method sets the porperty of a given entity by transforming the text into the correct type. This is used when a property is loaded from a file.

Implements PropertyVisualizer.

Definition at line 149 of file OMPropertyVisualizerT_impl.hh.

## ◆ visualize()

template<typename MeshT >

void OMPropertyVisualizer< MeshT >::visualize | ( | bool | _setDrawMode,
|  | QWidget * | _widget
| ) |  |
| virtual

Visualizes the property.

To visualize the property this method calls the corresponding visualization method visualizeFaceProp, -EdgeProp, -HalfedgeProp or -VertexProp depending on the entity type of the property.

Reimplemented from PropertyVisualizer.

Definition at line 303 of file OMPropertyVisualizerT_impl.hh.

The documentation for this class was generated from the following files:

- Plugin-PropertyVis/OpenMesh/OMPropertyVisualizer.hh
- Plugin-PropertyVis/OpenMesh/OMPropertyVisualizerT_impl.hh